/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.configuracioneccomerciales;

import com.rjconsultores.ventaboletos.entidad.AlertaCtrl;
import com.rjconsultores.ventaboletos.entidad.ClaseServicio;
import com.rjconsultores.ventaboletos.entidad.Parada;
import com.rjconsultores.ventaboletos.entidad.Ruta;
import com.rjconsultores.ventaboletos.service.ClaseServicioService;
import com.rjconsultores.ventaboletos.service.RutaService;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderAlertaCtrl;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zkplus.databind.BindingListModelList;
import org.zkoss.zul.Combobox;
import org.zkoss.zul.Comboitem;
import org.zkoss.zul.Intbox;
import org.zkoss.zul.Paging;
import org.zkoss.zul.Radio;

/**
 * 
 * @author Administrador
 */
@Controller("busquedaAlertaCtrlController")
@Scope("prototype")
public class BusquedaAlertaCtrlController extends MyGenericForwardComposer {

	private static final long serialVersionUID = 1L;
	@Autowired
	private transient PagedListWrapper<AlertaCtrl> plwAlertaCtrl;
	@Autowired
	private RutaService rutaService;
	@Autowired
	private ClaseServicioService claseServicioService;
	private List<ClaseServicio> lsClaseServicio;
	private MyListbox alertaCtrlList;
	private Paging pagingAlertaCtrl;
	private Combobox cmbRuta;
	private Combobox cmbOrigem;
	private Combobox cmbDestino;
	private Combobox cmbClaseServicio;
	private List<Ruta> lsRuta;
	private Intbox txtIdCorrida;
	private Radio rdAlta;
	private Radio rdBaja;

	public List<Ruta> getLsRuta() {
		return lsRuta;
	}

	public void setLsRuta(List<Ruta> lsRuta) {
		this.lsRuta = lsRuta;
	}

	@Override
	public void doAfterCompose(Component comp) throws Exception {
		super.doAfterCompose(comp);

		lsRuta = new ArrayList<Ruta>();

		alertaCtrlList.setItemRenderer(new RenderAlertaCtrl());
		alertaCtrlList.addEventListener("onDoubleClick", new EventListener() {

			@Override
			public void onEvent(Event event) throws Exception {
				AlertaCtrl c = (AlertaCtrl) alertaCtrlList.getSelected();
				verAlertaCtrl(c);
			}
		});

		refreshLista();

		lsClaseServicio = claseServicioService.obtenerTodos();
		BindingListModelList modelClaseServicio = new BindingListModelList(lsClaseServicio, true);
		cmbClaseServicio.setModel(modelClaseServicio);

		cmbClaseServicio.focus();
	}

	@SuppressWarnings({ "rawtypes", "unchecked" })
	private void verAlertaCtrl(AlertaCtrl a) {
		if (a == null) {
			return;
		}

		Map args = new HashMap();
		args.put("alertaCtrl", a);
		args.put("alertaCtrlList", alertaCtrlList);

		openWindow("/gui/configuraciones_comerciales/editarAlertaCtrl.zul",
				Labels.getLabel("busquedaAlertaCtrlController.window.title"), args, MODAL);
	}

	private void refreshLista() {
		HibernateSearchObject<AlertaCtrl> alertaCtrlBusqueda =
				new HibernateSearchObject<AlertaCtrl>(AlertaCtrl.class,
						pagingAlertaCtrl.getPageSize());
		alertaCtrlBusqueda.addFilterEqual("activo", Boolean.TRUE);

		Comboitem cbiRuta = cmbRuta.getSelectedItem();
		if (cbiRuta != null) {
			Ruta ruta = (Ruta) cbiRuta.getValue();
			alertaCtrlBusqueda.addFilterEqual("ruta", ruta);
		}

		Comboitem cbiOrigem = cmbOrigem.getSelectedItem();
		if (cbiOrigem != null) {
			Parada origem = (Parada) cbiOrigem.getValue();
			alertaCtrlBusqueda.addFilterEqual("origem", origem);
		}

		Comboitem cbiDestino = cmbDestino.getSelectedItem();
		if (cbiDestino != null) {
			Parada destino = (Parada) cbiDestino.getValue();
			alertaCtrlBusqueda.addFilterEqual("destino", destino);
		}

		Comboitem cbiClaseServicio = cmbClaseServicio.getSelectedItem();
		if (cbiClaseServicio != null) {
			ClaseServicio claseServicio = (ClaseServicio) cbiClaseServicio.getValue();
			alertaCtrlBusqueda.addFilterEqual("claseServicio", claseServicio);
		}

		Integer idCorrida = txtIdCorrida.getValue();
		if (idCorrida != null) {
			alertaCtrlBusqueda.addFilterEqual("corrida.id.corridaId", idCorrida);
		}

		if (rdAlta.isChecked()) {
			alertaCtrlBusqueda.addFilterNotNull("porcalta");
			alertaCtrlBusqueda.addFilterNull("porcbaja");
		} else if (rdBaja.isChecked()) {
			alertaCtrlBusqueda.addFilterNotNull("porcbaja");
			alertaCtrlBusqueda.addFilterNull("porcalta");
		}

		plwAlertaCtrl.init(alertaCtrlBusqueda, alertaCtrlList, pagingAlertaCtrl);
		if (alertaCtrlList.getData().length == 0) {
			try {
				Messagebox.show(Labels.getLabel("MSG.ningunRegistro"),
						Labels.getLabel("busquedaAlertaCtrlController.window.title"),
						Messagebox.OK, Messagebox.INFORMATION);
			} catch (InterruptedException ex) {
			}
		}
	}

	public void onClick$btnPesquisa(Event ev) {
		refreshLista();
	}

	public void onClick$btnRefresh(Event ev) {
		refreshLista();
	}

	public void onClick$btnNovo(Event ev) {
		verAlertaCtrl(new AlertaCtrl());
	}

	public void onChange$cmbClaseServicio(Event ev) {
		Comboitem cbiClaseServicio = cmbClaseServicio.getSelectedItem();

		if (cbiClaseServicio != null) {
			ClaseServicio claseServicio = (ClaseServicio) cbiClaseServicio.getValue();
			lsRuta = rutaService.buscarPorClaseServicio(claseServicio);

			cmbRuta.setSelectedItem(null);
			cmbRuta.setText(null);

			BindingListModelList modelRuta = new BindingListModelList(lsRuta, true);
			cmbRuta.setModel(modelRuta);
		}
	}
}
